Package com.io7m.jtensors.storage.bytebuffered

# Class MatrixByteBuffered3x3s16

java.lang.Object
com.io7m.jtensors.storage.bytebuffered.MatrixByteBuffered3x3s16

All Implemented Interfaces:
  `MatrixReadable3x3DType`, `MatrixReadableDType`, `MatrixStorageType`, `MatrixStorage3x3Type`, `MatrixByteBuffered3x3Type`, `MatrixByteBufferedType`, `TensorByteBufferedType`

public final class MatrixByteBuffered3x3s16 extends Object implements MatrixByteBuffered3x3Type

A storage matrix.

Storage component type: `binary16`

Storage component count: `3x3`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final ByteBuffer`
  `byteBuffer()`
  `final long`
  `byteOffset()`
  `protected final int`
  `byteOffsetForIndex(int component_index)`
  `protected final int`
  `componentBytes()`
  `protected int`
  `componentCount()`
  `static MatrixByteBuffered3x3s16`
  `createWithBase(ByteBuffer b, com.io7m.mutable.numbers.core.MutableLongType base, int offset)`
  Return a new vector that is backed by the given byte buffer `b`
  `final int`
  `offset()`
  `double`
  `r0c0()`
  `double`
  `r0c1()`
  `double`
  `r0c2()`
  `double`
  `r1c0()`
  `double`
  `r1c1()`
  `double`
  `r1c2()`
  `double`
  `r2c0()`
  `double`
  `r2c1()`
  `double`
  `r2c2()`
  `void`
  `setMatrix3x3D(Matrix3x3D m)`
  Set the components from the given matrix.
  `void`
  `setMatrix3x3F(Matrix3x3F m)`
  Set the components from the given matrix.
  `final int`
  `sizeBytes()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface com.io7m.jtensors.core.unparameterized.matrices.MatrixReadable3x3DType

  `rowColumn`

  ### Methods inherited from interface com.io7m.jtensors.storage.bytebuffered.TensorByteBufferedType

  `byteBuffer, byteOffset, offset, sizeBytes`

- ## Method Details

  - ### createWithBase

    public static MatrixByteBuffered3x3s16 createWithBase(ByteBuffer b, com.io7m.mutable.numbers.core.MutableLongType base, int offset)

    Return a new vector that is backed by the given byte buffer `b`

    The data for the instance will be taken from the data at the current value of `base.get() + offset`, each time a field is requested or set.

    No initialization of the data is performed.

    Parameters:
      `b` - The byte buffer
      `base` - The base address
      `offset` - A constant offset
    Returns:
      A new buffered vector

  - ### componentCount

    protected int componentCount()

  - ### r0c0

    public double r0c0()
    Specified by:
      `r0c0` in interface `MatrixReadable3x3DType`
    Returns:
      The value at row 0 column 0

  - ### r0c1

    public double r0c1()
    Specified by:
      `r0c1` in interface `MatrixReadable3x3DType`
    Returns:
      The value at row 0 column 1

  - ### r0c2

    public double r0c2()
    Specified by:
      `r0c2` in interface `MatrixReadable3x3DType`
    Returns:
      The value at row 0 column 2

  - ### r1c0

    public double r1c0()
    Specified by:
      `r1c0` in interface `MatrixReadable3x3DType`
    Returns:
      The value at row 1 column 0

  - ### r1c1

    public double r1c1()
    Specified by:
      `r1c1` in interface `MatrixReadable3x3DType`
    Returns:
      The value at row 1 column 1

  - ### r1c2

    public double r1c2()
    Specified by:
      `r1c2` in interface `MatrixReadable3x3DType`
    Returns:
      The value at row 1 column 2

  - ### r2c0

    public double r2c0()
    Specified by:
      `r2c0` in interface `MatrixReadable3x3DType`
    Returns:
      The value at row 2 column 0

  - ### r2c1

    public double r2c1()
    Specified by:
      `r2c1` in interface `MatrixReadable3x3DType`
    Returns:
      The value at row 2 column 1

  - ### r2c2

    public double r2c2()
    Specified by:
      `r2c2` in interface `MatrixReadable3x3DType`
    Returns:
      The value at row 2 column 2

  - ### setMatrix3x3D

    public void setMatrix3x3D(Matrix3x3D m)
    Description copied from interface: `MatrixStorage3x3Type`
    Set the components from the given matrix.
    Specified by:
      `setMatrix3x3D` in interface `MatrixStorage3x3Type`
    Parameters:
      `m` - The source matrix

  - ### setMatrix3x3F

    public void setMatrix3x3F(Matrix3x3F m)
    Description copied from interface: `MatrixStorage3x3Type`
    Set the components from the given matrix.
    Specified by:
      `setMatrix3x3F` in interface `MatrixStorage3x3Type`
    Parameters:
      `m` - The source matrix

  - ### componentBytes

    protected final int componentBytes()

  - ### byteBuffer

    public final ByteBuffer byteBuffer()
    Specified by:
      `byteBuffer` in interface `TensorByteBufferedType`
    Returns:
      The byte buffer that backs the tensor

  - ### byteOffset

    public final long byteOffset()
    Specified by:
      `byteOffset` in interface `TensorByteBufferedType`
    Returns:
      The byte offset of the current tensor

  - ### offset

    public final int offset()
    Specified by:
      `offset` in interface `TensorByteBufferedType`
    Returns:
      A constant offset added to `TensorByteBufferedType.byteOffset()`.

  - ### sizeBytes

    public final int sizeBytes()
    Specified by:
      `sizeBytes` in interface `TensorByteBufferedType`
    Returns:
      The size of a single tensor in bytes

  - ### byteOffsetForIndex

    protected final int byteOffsetForIndex(int component_index)